from time import sleep

from core.joylink import JoylinkConfig, NewSDK
from example.device.device import MyDeviceCallbackHandler, DeviceInitialise
from util.log import getLogger
from util.util import parseJson

logger = getLogger("example")


def LoadConfigFromFile(path: str) -> JoylinkConfig:
    config: JoylinkConfig
    with open(path, "r") as f:
        data_str = f.read()
        logger.info(data_str)
        config = parseJson(data_str, clazz=JoylinkConfig)
        f.close()
    return config


# 主函数
def RunExample():
    # 加载joylink配置文件
    joyConfig = LoadConfigFromFile("example/res/joylink_config.json")

    # 创建 SDK
    joySDK = NewSDK(joyConfig)
    joySDK.Welcome()

    # 初始化 SDK
    joySDK.Initialise()

    # 设置设备回调函数
    joySDK.SetDevCallBackHandler(MyDeviceCallbackHandler())

    # 初始化设备
    DeviceInitialise(joySDK, joyConfig.deviceId)

    # SDK 连接
    joySDK.Connect()

    # while
    while True:
        print('Sleep...')
        sleep(10000000)
