import datetime
import json
import inspect

import numpy as np


class JsonObj:
    __trans: dict = {}

    def __init__(self, trans=None):
        if trans is not None:
            self.__trans = trans
        pass

    def get_trans(self):
        return self.__trans


class MyJsonEncoder(json.JSONEncoder):
    def default(self, obj):
        if isinstance(obj, JsonObj):
            res: dict = {}
            normal_attrs = [attr for attr in obj.__dir__() if
                            not (attr.startswith('__') or attr.startswith('_JsonObj__') or attr == 'get_trans')]
            for key in normal_attrs:
                res[key] = obj.__getattribute__(key)
                if inspect.isfunction(res[key]):
                    res.pop(key, None)
            # 处理json翻译字段
            trans = obj.get_trans()
            for k, v in trans.items():
                res[v] = res[k]
                res.pop(k, None)
            return res
        # elif isinstance(obj, datetime.datetime):
        #     print("MyEncoder-datetime.datetime")
        #     return obj.strftime("%Y-%m-%d %H:%M:%S")
        elif isinstance(obj, (np.integer, np.floating, np.bool_)):
            return obj.item()
        elif isinstance(obj, np.ndarray):
            return obj.tolist()
        elif isinstance(obj, bytes):
            return str(obj, encoding='utf-8')
        # elif isinstance(obj, array):
        #    return obj.tolist()
        else:
            return super(MyJsonEncoder, self).default(obj)


# json自定义解码器
class MyJsonDecoder(json.JSONDecoder):

    def __init__(self, *args, **kwargs):
        super().__init__(object_hook=self.object_hook, *args, **kwargs)

    def object_hook(self, o):
        if isinstance(o, JsonObj):
            print("---")
            return o
        return o
