import numpy as np

from util.JsonWrapper import JsonObj


# 设备上下线结构体定义
class OnlineStatus(JsonObj):
    deviceId: str = None
    timestamp: np.int64 = 0
    messageId: str = None
    events: str = None
    # thing-model
    thingModel: str = None

    def __init__(self):
        super(OnlineStatus, self).__init__({"thingModel": "thing-model"})
        pass


# 事件
class EventPostEvent(JsonObj):
    key: str = None
    parameters: dict = {}


# 事件上报
class EventPost(JsonObj):
    deviceId: str = None
    timestamp: np.int64 = 0
    messageId: str = None
    events: list[EventPostEvent] = []
