import numpy as np

from util.JsonWrapper import JsonObj


# 物模型结构体定义
class ThingModel(JsonObj):
    id: str = None
    # thing-model-version
    version: str = None

    def __init__(self):
        super(ThingModel, self).__init__({"version": "thing-model-version"})
        pass


# 物模型上报结构体定义
class ThingModelPost(JsonObj):
    deviceId: str = None
    timestamp: np.int64 = 0
    messageId: str = None
    # thing-model
    model: ThingModel = None

    def __init__(self):
        super(ThingModelPost, self).__init__({"model": "thing-model"})
        pass


# 物模型上报响应结构体定义
class ThingModelPostRes(JsonObj):
    deviceId: str = None
    timestamp: np.int64 = 0
    messageId: str = None
    code: np.int32 = 200
    message: str = None
